<template>
  <div v-if="data">
    <div class="single-grid space-between">
      <div class="col-8">
        <Information :date="data.created_at" :location="data.location" />
        <div class="single-title">
          {{ data.name }}
          <Button
            v-if="user && data.user && user.id === data.user.id"
            icon
            variant="none"
            size="inline"
            @click="$emit('onEdit')"
          >
            <svg-icon name="pencil" />
          </Button>
        </div>
        <div v-if="data.comment" class="single-description">
          {{ data.comment }}
        </div>

        <Clients v-if="type == 'event'" :customer="data.customer" />

        <div v-if="data.tags && type == 'album'" class="single-tags">
          <div v-for="(item, index) in data.tags" :key="index">
            <span>{{ item.tag.tag }}</span>
          </div>
        </div>
      </div>

      <div
        v-if="data.payment_types && data.payment_types.length > 0"
        class="col-4 self-end"
      >
        <Payment :payment="data.payment_types" />
      </div>
    </div>

    <div class="single-grid space-between">
      <div class="col-4">
        <div v-if="data.statistics" class="single-statistic">
          <div>
            <div class="single-statistic__top">income</div>
            <div class="single-statistic__content">
              {{ data.statistics.income }}$
            </div>
          </div>

          <div>
            <div class="single-statistic__top">Downloads</div>
            <div class="single-statistic__content">
              {{ data.statistics.downloads }}
              <span>+{{ data.statistics.new_downloads }}</span>
            </div>
          </div>
          <div>
            <div class="single-statistic__top">Visits</div>
            <div class="single-statistic__content">
              {{ data.statistics.visits }}
              <span>+{{ data.statistics.visits }}</span>
            </div>
          </div>
        </div>
      </div>
      <div class="col-8 self-end">
        <div class="single-button" style="align-items: inherit">
          <div>
            <Button
              size="small"
              variant="primary"
              :to="localePath(`/${type}/${data.id}`)"
              target="_blank"
              style="height: 100%"
              :disabled="data.private"
            >
              <svg-icon style="margin: 0" name="external-link" />
            </Button>
          </div>
          <div>
            <Button
              size="small"
              variant="grey"
              @click="$emit('onShare')"
              :disabled="data.private"
            >
              <svg-icon name="share" style="margin: 0; fill: #0065ff" />
            </Button>
          </div>
          <div>
            <Button
              size="inline"
              :variant="data.private ? 'success' : 'grey'"
              @click="$emit('onPrivate')"
            >
              <span>{{ $t('buttons.private') }}</span>
              <svg-icon
                name="lock"
                :style="data.private ? 'fill: #1b2234' : 'fill: #00ffb3'"
              />
            </Button>
          </div>
          <div>
            <Button
              size="inline"
              variant="danger-opacity"
              @click="$emit('onDelete')"
            >
              <span>{{ $t('buttons.delete') }}</span>
            </Button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, computed } from '@nuxtjs/composition-api'

import elTag from '@/components/element/Tag.vue'
import Button from '@/components/ui/Button.vue'
import BackButton from '@/components/ui/BackButton.vue'
import Payment from '@/components/ui/Payment.vue'
import Clients from '@/components/ui/Clients.vue'
import Information from '@/components/ui/Information.vue'

export default defineComponent<{
  data: any
  type: string
}>({
  name: 'PrivatePage',
  props: ['data', 'type'],
  components: {
    Button,
    BackButton,
    elTag,
    Payment,
    Clients,
    Information
  },
  setup(props, { root }) {
    const user = computed(() => root.$accessor.auth.user)
    return { user }
  }
})
</script>

<style lang="scss" scoped>
.single {
  &-grid {
    display: grid;
    grid-template-columns: repeat(12, 1fr);
    grid-row-gap: 30px;
    margin-bottom: 30px;

    @media (min-width: 1199.98px) {
      grid-gap: 35px;
      margin-bottom: 50px;
    }
    &.space-between {
      justify-content: space-between;
    }

    & {
      .col-3,
      .col-4,
      .col-5,
      .col-6,
      .col-7,
      .col-8,
      .col-12 {
        grid-column: span 12;
      }

      @media (min-width: 1199.98px) {
        & .self-end {
          justify-self: flex-end;
        }

        .col-3 {
          grid-column: span 3;
        }

        .col-4 {
          grid-column: span 4;
        }

        .col-5 {
          grid-column: span 5;
        }

        .col-6 {
          grid-column: span 6;
        }

        .col-7 {
          grid-column: span 7;
        }

        .col-8 {
          grid-column: span 8;
        }

        .col-12 {
          grid-column: span 12;
        }
      }
    }
  }

  &-title {
    font-size: 30px;
    line-height: 30px;
    color: #ffffff;
    display: flex;
    align-items: center;
    margin-bottom: 15px;

    &:last-child {
      margin-bottom: 0px;
    }

    @media (min-width: 1199.98px) {
      font-size: 55px;
      line-height: 55px;
    }

    ::v-deep .btn[icon] {
      width: 50px;
      height: 50px;
      border-radius: 50%;
      background: #272c3b;
      margin-left: 25px;
      padding: 0px;
      flex: none;

      svg {
        fill: #00ffb3;
        width: 13px;
        height: 13px;
      }
    }
  }

  &-description {
    font-size: 20px;
    line-height: 24px;
    letter-spacing: 0px;
    color: #9badd6;
    margin-bottom: 30px;

    @media (min-width: 1199.98px) {
      font-size: 30px;
      line-height: 36px;
    }
  }

  &-tags {
    display: flex;
    align-items: center;
    overflow-x: auto;
    overflow-y: hidden;
    margin-right: -30px;
    margin-left: -30px;
    padding-left: 30px;
    padding-right: 15px;
    white-space: nowrap;

    > div {
      padding-right: 15px;
      flex: none;
    }

    span,
    a {
      display: block;
      padding: 4px 15px;
      background: 0;
      border: 1px solid #0065ff;
      border-radius: 17px;
      text-align: left;
      font-weight: 500;
      font-size: 18px;
      line-height: 25px;
      letter-spacing: 0px;
      color: #9badd6;
    }
  }

  &-statistic {
    display: flex;
    align-items: flex-start;
    flex-wrap: nowrap;
    margin-right: -30px;
    margin-left: -30px;
    padding-left: 30px;
    overflow-x: auto;
    overflow-y: hidden;
    white-space: nowrap;

    > div {
      padding-right: 30px;
      flex: none;
    }

    @media (min-width: 1199.98px) {
      margin-right: -50px;

      > div {
        padding-right: 50px;
      }
    }

    &__top {
      font-weight: bold;
      font-size: 14px;
      line-height: 16px;
      color: #7683ad;
      text-transform: uppercase;
      margin-bottom: 5px;

      @media (min-width: 1199.98px) {
        font-size: 16px;
        line-height: 20px;
      }
    }

    &__content {
      display: flex;
      align-items: flex-start;
      font-weight: bold;
      font-size: 50px;
      line-height: 50px;
      letter-spacing: 0px;
      color: #ffffff;

      span {
        font-weight: 500;
        font-size: 14px;
        line-height: 20px;
        letter-spacing: 0px;
        color: #00ffb3;
        margin-left: 3px;
      }

      @media (min-width: 1199.98px) {
        font-size: 55px;
        line-height: 55px;

        span {
          font-size: 20px;
          line-height: 27px;
        }
      }
    }
  }

  &-button {
    display: flex;
    flex-wrap: wrap;
    flex-direction: column;

    @media (min-width: 1199.98px) {
      align-items: center;
      flex-direction: row;
    }

    > div {
      flex: 1;
      padding-bottom: 15px;

      @media (min-width: 1199.98px) {
        flex: 0 0 auto;
        padding-right: 20px;
        padding-bottom: 0px;
      }

      &:last-child {
        padding-right: 0px;
        padding-bottom: 0px;
      }
    }

    ::v-deep .btn {
      text-transform: uppercase;
      font-weight: bold;

      @media (max-width: 1199.98px) {
        width: 100%;
        display: flex;
      }
    }
  }
}

.feed {
  &-info {
    font-size: 0px;
    margin-bottom: 20px;

    @media (min-width: 1199.98px) {
      display: flex;
      align-items: flex-end;
      margin-bottom: 30px;
    }

    &.align-center {
      align-items: center;
    }

    &__title {
      font-size: 35px;
      line-height: 35px;
      letter-spacing: -0.88px;
      color: #ffffff;
      margin-right: 30px;
    }

    &__descr {
      font-weight: 500;
      font-size: 18px;
      line-height: 23px;
      letter-spacing: 0px;
      color: #9badd6;
    }
  }

  &__row {
    display: grid;
    grid-template-columns: repeat(12, 1fr);
    grid-template-rows: repeat(2, 1fr);
    grid-column-gap: 20px;
    grid-row-gap: 20px;
    font-size: 0px;

    ::v-deep .el-checkbox-group {
      display: grid;
      grid-template-columns: repeat(12, 1fr);
      grid-template-rows: repeat(2, 1fr);
      grid-column-gap: 20px;
      grid-row-gap: 20px;
      font-size: 0px;
      grid-column: span 12;
    }

    ::v-deep .el-checkbox {
      position: absolute;
      right: 20px;
      top: 15px;

      &__inner {
        margin: 0;

        &::after {
          border: 3px solid #272c3b;
          border-left: 0;
          border-top: 0;
          width: 7px;
          height: 11px;
          left: 12px;
          top: 8px;
        }
      }

      &__label {
        display: none;
      }

      &__input {
        &.is-checked {
          .el-checkbox__inner {
            background: #00ffb3;
          }
        }
      }
    }
  }

  &__item {
    grid-column: span 6;
    grid-row: span 1;
    position: relative;

    @media (min-width: 1199.98px) {
      grid-column: span 3;
    }

    img {
      width: 100%;
      object-fit: cover;
      height: 150px;
      border-radius: 5px;

      @media (min-width: 1199.98px) {
        height: 230px;
      }
    }

    @media (min-width: 1199.98px) {
      &:nth-child(1),
      &:nth-child(8),
      &:nth-child(11),
      &:nth-child(18),
      &:nth-child(21),
      &:nth-child(28) {
        grid-column: span 6;
        grid-row: span 2;

        img {
          height: 480px;
        }
      }
    }
  }
}

.map-popap {
  position: fixed;
  left: 0px;
  right: 0px;
  top: 0px;
  bottom: 0px;
  padding: 0px;
  background: rgba(#252d45, 0.5);
  z-index: 999999;
  &__close {
    position: absolute;
    right: 20px;
    top: 20px;
    width: 60px;
    height: 60px;
    background: #252d45;
    border-radius: 50px;
    z-index: 999;
    display: flex;
    align-items: center;
    justify-content: center;
    box-shadow: -1px 3px 37px rgb(0 0 0 / 15%);
    cursor: pointer;
    svg {
      width: 15px;
      height: 15px;
      fill: #00ffb3;
    }
  }
  #map {
    width: 100%;
    height: 100%;
  }
  button {
    position: absolute;
    left: 30px;
    bottom: 30px;
    width: auto;
    min-height: auto;
    z-index: 999;
  }
}
</style>
